using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinEditors;
using System.Resources;
using Infragistics.Win;

namespace UltraGanttViewPrintDemo_CS
{
    public partial class frmGanttViewPrintDemo : Form
    {
       #region Private Members
        ResourceManager rm = UltraGanttViewPrintDemo_CS.Properties.Resources.ResourceManager;
        // Create a new Project other than the Unassigned Project
       private Project sampleProject;
        #endregion 

       #region Constructor
       public frmGanttViewPrintDemo()
        {
            InitializeComponent();
        }
       #endregion

       #region CreateOwners

        private void CreateOwners()
        {
            this.ultraCalendarInfo1.Owners.Add("Jon");
            this.ultraCalendarInfo1.Owners.Add("Jim");
            this.ultraCalendarInfo1.Owners.Add("Tom");
            this.ultraCalendarInfo1.Owners.Add("Kim");
            this.ultraCalendarInfo1.Owners.Add("Ted");
            this.ultraCalendarInfo1.Owners.Add("Jun");
            this.ultraCalendarInfo1.Owners.Add("Daniel");
            this.ultraCalendarInfo1.Owners.Add("Kathey");
            this.ultraCalendarInfo1.Owners.Add("Jane");
        }
        #endregion

       #region Create Tasks
        public void CreateData()
        {
            sampleProject = new Project();
            sampleProject.Key = "Project1";
            sampleProject.Name = rm.GetString("SampleProject");
            sampleProject.StartDate = DateTime.Today;

            // Assign sample project to the projects in calendarInfo object.
            this.ultraCalendarInfo1.Projects.Add(sampleProject);
            // Assign calendarInfo object to the GanttView control.
            this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
            // Assign sample project to the GanttView control.
            this.ultraGanttView1.Project = this.ultraGanttView1.CalendarInfo.Projects["Project1"];


            //Add Root Tasks
            Task rootTask = this.ultraCalendarInfo1.Tasks.Add(DateTime.Today, TimeSpan.FromDays(20), rm.GetString("RootTask"), ultraCalendarInfo1.Projects[1].Key);

            for (int i = 1; i <= 5; i++)
            {
                Task parentTask = rootTask.Tasks.Add(TimeSpan.FromDays(4), String.Format(rm.GetString("ParentTask"), i));

                //Add sub tasks
                //Task childTask1 = parentTask.Tasks.Add(DateTime.Today.AddDays(3), TimeSpan.FromDays(5), String.Format("Child Task {0}.1", i));
                Task childTask1 = parentTask.Tasks.Add(DateTime.Today.AddDays(3), TimeSpan.FromDays(5), String.Format(rm.GetString("ChildTask")+" {0}.1", i));
                //Add sub tasks to the above ChildTask1
                Task childTask11 = childTask1.Tasks.Add(DateTime.Today.AddDays(2), TimeSpan.FromDays(1), String.Format(rm.GetString("ChildTask") + " {0}.1.1", i));
                Task childTask12 = childTask1.Tasks.Add(DateTime.Today.AddDays(5), TimeSpan.FromDays(3), String.Format(rm.GetString("ChildTask") + " {0}.1.2", i));
                
                //Add another sub task to the parent task
                Task childTask2 = parentTask.Tasks.Add(DateTime.Today.AddDays(2), TimeSpan.FromDays(5), String.Format(rm.GetString("ChildTask") + " {0}.2", i));
                //Add sub tasks to the above ChildTask1
                Task childTask21 = childTask2.Tasks.Add(DateTime.Today.AddDays(4), TimeSpan.FromDays(1), String.Format(rm.GetString("ChildTask") + " {0}.2.1", i));
                Task childTask22 = childTask2.Tasks.Add(DateTime.Today.AddDays(1), TimeSpan.FromDays(6), String.Format(rm.GetString("ChildTask") + " {0}.2.2", i));
                Task childTask23 = childTask2.Tasks.Add(DateTime.Today.AddDays(5), TimeSpan.FromDays(4), String.Format(rm.GetString("ChildTask") + " {0}.2.3", i));
                
                //Add another sub task to the Parent task
                Task childTask3 = parentTask.Tasks.Add(DateTime.Today.AddDays(3), TimeSpan.FromDays(3), String.Format(rm.GetString("ChildTask") + " {0}.3", i));
                //Add sub tasks to the above ChildTask1
                Task childTask31 = childTask3.Tasks.Add(DateTime.Today.AddDays(2), TimeSpan.FromDays(2), String.Format(rm.GetString("ChildTask") + " {0}.3.1", i));
                Task childTask32 = childTask3.Tasks.Add(DateTime.Today.AddDays(4), TimeSpan.FromDays(5), String.Format(rm.GetString("ChildTask") + " {0}.3.2", i));
                //Add Dependencies
                childTask12.Dependencies.Add(childTask11, TaskDependencyType.FinishToStart);
                childTask21.Dependencies.Add(childTask12, TaskDependencyType.StartToStart);
                childTask22.Dependencies.Add(childTask23, TaskDependencyType.FinishToFinish);
                childTask31.Dependencies.Add(childTask21, TaskDependencyType.StartToFinish);
                childTask32.Dependencies.Add(childTask31, TaskDependencyType.StartToFinish);
                childTask23.Dependencies.Add(childTask11, TaskDependencyType.StartToStart);

                //Add Resources
                childTask1.Resources.Add("Jon");
                childTask11.Resources.Add("Jim");
                childTask12.Resources.Add("Tom");
                childTask2.Resources.Add("Ted");
                childTask21.Resources.Add("Kim");
                childTask22.Resources.Add("Jun");
                childTask23.Resources.Add("Daniel");
                childTask3.Resources.Add("Kathy");
                childTask31.Resources.Add("Jon");
                childTask32.Resources.Add("Jane");
                
                //Add Milestones
                childTask1.Milestone = true;
                childTask12.Milestone = true;
                childTask32.Milestone = true;

                //Add Percent Complete
                childTask12.PercentComplete =80;
                childTask21.PercentComplete = 20;
                childTask31.PercentComplete = 90;
                childTask32.PercentComplete = 20;

                //Add Deadline
                childTask22.Deadline = DateTime.Today.AddDays(10);
                childTask11.Deadline = DateTime.Today.AddDays(5);
                childTask21.Deadline = DateTime.Today.AddDays(10);
                childTask32.Deadline = DateTime.Today.AddDays(15);
            }

        }
        #endregion Create Tasks

       #region Legend Appearances

        private AppearanceBase RetrieveAppearanceBasedOnIndex(int index, out string description)
        {
            // Retrieve the appropriate Appearance object (and description) based on the provided index.

            switch (index)
            {
                case 0: // Legend Appearance
                    description = rm.GetString("DescriptionLegendAppearance");
                    return this.ultraGanttViewPrintDocument1.LegendSettings.Appearance;

                case 1: //  Details Area Appearance
                    description = rm.GetString("DescriptionDetailsAreaAppearance");
                    return this.ultraGanttViewPrintDocument1.LegendSettings.DetailsAreaSettings.Appearance;

                case 2: //  Key Area Appearance
                    description = rm.GetString("DescriptionKeyAreaAppearance");
                    return this.ultraGanttViewPrintDocument1.LegendSettings.KeyAreaSettings.Appearance;

                default:
                    description = rm.GetString("DescriptionDefault");
                    return null;
            }
        }

        #endregion // Legend Appearances

        private void frmGanttViewPrintDemo_Load(object sender, EventArgs e)
        {
            this.CreateOwners();
            this.CreateData();
            this.ultraGanttViewPrintDocument1.GanttView = this.ultraGanttView1;
            this.ultraPrintPreviewDialog1.Document = this.ultraGanttViewPrintDocument1;

            this.cmbShowLegend.DataSource = Enum.GetValues(typeof(Infragistics.Win.UltraWinGanttView.ShowLegend));
            this.cmbShowLegend.SelectedIndex = 1;

            this.editDetailsAreaWidth.MinValue = 0;
            this.editDetailsAreaWidth.MaxValue = 5;

            this.cmbLegendAppearances.SelectedIndex = 0;

            this.txtCenter.Text = rm.GetString("DatePrinted");
            this.txtRight.Text = rm.GetString("TimePrinted");

            this.cmbAutoSize.DataSource = Enum.GetValues(typeof(Infragistics.Win.UltraWinGanttView.AutoSize));
            this.cmbAutoSize.SelectedIndex = 3;

            this.cmbPrintColorStyle.DataSource = Enum.GetValues(typeof(Infragistics.Win.ColorRenderMode));
            this.cmbPrintColorStyle.SelectedIndex = 0;

            this.edPrintNoOfColumns.MinValue = 1;
            this.edPrintNoOfColumns.MaxValue = 7;
            this.edPrintNoOfColumns.Value = 7;

            this.cmbLegendAppearances.ValueList.ValueListItems.Add(rm.GetString("LegendAppearance"));
            this.cmbLegendAppearances.ValueList.ValueListItems.Add(rm.GetString("DetailsAreaAppearance"));
            this.cmbLegendAppearances.ValueList.ValueListItems.Add(rm.GetString("KeyAreaAppearance"));
        }

        private void btnPrintPreview_Click(object sender, EventArgs e)
        {
            this.ultraGanttViewPrintDocument1.LegendSettings.DetailsAreaSettings.TextCenter = this.txtCenter.Text;
            this.ultraGanttViewPrintDocument1.LegendSettings.DetailsAreaSettings.TextRight = this.txtRight.Text;
            this.ultraPrintPreviewDialog1.ShowDialog(this);
        }

        private void cmbShowLegend_ValueChanged(object sender, EventArgs e)
        {
            UltraComboEditor currentItem = (UltraComboEditor)sender;
            this.ultraGanttViewPrintDocument1.LegendSettings.ShowLegend = (Infragistics.Win.UltraWinGanttView.ShowLegend)currentItem.Value;
        }

        private void editDetailsAreaWidth_ValueChanged(object sender, EventArgs e)
        {
            UltraNumericEditor numEditor = (UltraNumericEditor)sender;
            this.ultraGanttViewPrintDocument1.LegendSettings.DetailsAreaWidth = (int)numEditor.Value;

        }
        
        private void cmbLegendAppearances_ValueChanged(object sender, EventArgs e)
        {
            string description;
            UltraComboEditor combo = (UltraComboEditor)sender;

            // Retrieve the Appearance object based on the selected index, and set it to the PropertyGrid
            this.pgLegendAppearances.SelectedObject = RetrieveAppearanceBasedOnIndex(combo.SelectedIndex, out description);

            // Update the Appearance Description label
            this.lblAppearance.Text = description;
                                    
        }

        private void ultraGanttViewPrintDocument1_InitializeGanttView(object sender, Infragistics.Win.UltraWinGanttView.Printing.InitializeGanttViewEventArgs e)
        {
            e.Control.GridSettings.ColumnSettings[TaskField.Duration].Visible = DefaultableBoolean.False;
            e.Control.GridSettings.ColumnSettings[TaskField.Resources].VisiblePosition = 1;
            
        }

        private void cmbAutoSize_ValueChanged(object sender, EventArgs e)
        {
            UltraComboEditor currentItem = (UltraComboEditor)sender;
            this.ultraGanttViewPrintDocument1.AutoSize = (Infragistics.Win.UltraWinGanttView.AutoSize)currentItem.Value;
        }

        private void cmbPrintColorStyle_ValueChanged(object sender, EventArgs e)
        {
            UltraComboEditor currentItem = (UltraComboEditor)sender;
            this.ultraGanttViewPrintDocument1.PrintColorStyle = (Infragistics.Win.ColorRenderMode)currentItem.Value;
        }

        private void edPrintNoOfColumns_ValueChanged(object sender, EventArgs e)
        {
            UltraNumericEditor numEditor = (UltraNumericEditor)sender;
            this.ultraGanttViewPrintDocument1.PrintXColumnsOnEveryPage = (int)numEditor.Value;
        }

        

       

        

        
    }
}